package com.ruoyi.oa.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.oa.domain.bo.OaArticleBo;
import com.ruoyi.oa.domain.vo.OaArticleVo;
import com.ruoyi.oa.domain.OaArticle;
import com.ruoyi.oa.mapper.OaArticleMapper;
import com.ruoyi.oa.service.IOaArticleService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 文章Service业务层处理
 *
 * @author Joshi
 * @date 2025-09-02
 */
@RequiredArgsConstructor
@Service
public class OaArticleServiceImpl implements IOaArticleService {

    private final OaArticleMapper baseMapper;

    /**
     * 查询文章
     */
    @Override
    public OaArticleVo queryById(Long articleId){
        return baseMapper.selectVoById(articleId);
    }

    /**
     * 查询文章列表
     */
    @Override
    public TableDataInfo<OaArticleVo> queryPageList(OaArticleBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OaArticle> lqw = buildQueryWrapper(bo);
        Page<OaArticleVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询文章列表
     */
    @Override
    public List<OaArticleVo> queryList(OaArticleBo bo) {
        LambdaQueryWrapper<OaArticle> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OaArticle> buildQueryWrapper(OaArticleBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OaArticle> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), OaArticle::getTitle, bo.getTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), OaArticle::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getAccessory()), OaArticle::getAccessory, bo.getAccessory());
        return lqw;
    }

    /**
     * 新增文章
     */
    @Override
    public Boolean insertByBo(OaArticleBo bo) {
        OaArticle add = BeanUtil.toBean(bo, OaArticle.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setArticleId(add.getArticleId());
        }
        return flag;
    }

    /**
     * 修改文章
     */
    @Override
    public Boolean updateByBo(OaArticleBo bo) {
        OaArticle update = BeanUtil.toBean(bo, OaArticle.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OaArticle entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除文章
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
